import type { ReactNode } from 'react';
export declare function reforwardJSX<Props, P = Omit<Props, 'children'>>(element: string): ((props?: P | undefined, ...children: ReactNode[]) => import("react").CElement<{
    children: ReactNode[];
}, import("react").Component<{
    children: ReactNode[];
}, any, any>>) | ((props?: P | undefined, ...children: ReactNode[]) => import("react").DOMElement<{}, Element>);
declare type FunctionalComponentFactory<P> = (props: P & JSX.IntrinsicAttributes & {
    children: ReactNode | ReactNode[];
}) => ReactNode | ReactNode[];
export declare function FunctionalComponent<P>(factory: FunctionalComponentFactory<P>): (props?: (P & JSX.IntrinsicAttributes) | undefined, ...children: ReactNode[]) => import("react").DetailedReactHTMLElement<import("react").InputHTMLAttributes<HTMLInputElement>, HTMLInputElement>;
export declare function VoidFunctionalComponent<P>(factory: FunctionalComponentFactory<P>): (props?: (P & JSX.IntrinsicAttributes) | undefined) => import("react").DetailedReactHTMLElement<import("react").InputHTMLAttributes<HTMLInputElement>, HTMLInputElement>;
export {};
